/*
 * Copyright (C) 2008  Remko Troncon
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <https://www.gnu.org/licenses/>.
 *
 */

#ifndef RANDOMNUMBERGENERATOR_H
#define RANDOMNUMBERGENERATOR_H

namespace XMPP {
class RandomNumberGenerator {
public:
    virtual ~RandomNumberGenerator();

    double generateNumberBetween(double a, double b) const;

protected:
    virtual double generateNumber() const            = 0;
    virtual double getMaximumGeneratedNumber() const = 0;
};
} // namespace XMPP

#endif // RANDOMNUMBERGENERATOR_H
